unit Test;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, ExtCtrls, DBCtrls, Grids, DBGrids, StdCtrls,
  SqlitePassDbo, MasterDetail, SqlitePassMasterDetailFieldsDialog,
  SqlitePassDataTypesDialog, SqlitePassCustomFieldDefsDialog, Menus;

type
  TForm1 = class(TForm)
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    DataSource1: TDataSource;
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    SqlitePassDataset1: TSqlitePassDataset;
    ChangeSql1: TButton;
    ChangeSql2: TButton;
    BtnFilter: TButton;
    SqlitePassDataset2: TSqlitePassDataset;
    BtnMasterFields: TButton;
    BtnMasterDetail: TButton;
    Button7: TButton;
    BtFieldDefsInfo: TButton;
    BtLocate: TButton;
    Button8: TButton;
    SqlitePassDatabase1: TSqlitePassDatabase;
    StoreToDatabase: TButton;
    LoadFromDatabase: TButton;
    Button9: TButton;
    Button10: TButton;
    BtCreateDatabase: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure SqlitePassDataset1CalcFields(DataSet: TDataSet);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure ChangeSql2Click(Sender: TObject);
    procedure ChangeSql1Click(Sender: TObject);
    procedure BtnFilterClick(Sender: TObject);
    procedure BtnMasterFieldsClick(Sender: TObject);
    procedure BtnMasterDetailClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SqlitePassDataset1FilterRecord(DataSet: TDataSet;
      var Accept: Boolean);
    procedure BtFieldDefsInfoClick(Sender: TObject);
    procedure BtLocateClick(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure StoreToDatabaseClick(Sender: TObject);
    procedure LoadFromDatabaseClick(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure BtCreateDatabaseClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;
  SqlitePassDatabase_1: TSqlitePassDatabase;
  SqlitePassDataset_1: TSqlitePassDataset;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
//TSqlitePassDataset(Datasource1.DataSet).DebugScreen := Memo1;
Self.WindowState := wsMaximized;
BtnFilterClick(Self);
//SqlitePassDataset1.DebugScreen := Memo1;
(*SqlitePassDatabase_1 := TSqlitePassDatabase.Create(Self);
SqlitePassDatabase_1.Name := 'SqlitePassDatabase1';
SqlitePassDatabase_1.Database := 'C:\MyLazarus\Components\SQLitePass\Demo\Databases\Copie (2) de Cars.kexi';
//SqlitePassDatabase_1.Database := 'C:\MyLazarus\Components\SQLitePass\Demo\Databases\EmptyTable.kexi';
//SqlitePassDatabase_1.Database := 'C:\MyLazarus\SQLitePass\Demo\Databases\Copie (2) de Cars.kexi';
SqlitePassDataset_1 := TSqlitePassDataset.Create(Self);
SqlitePassDataset_1.Name := 'SqlitePassDataset1';
SqlitePassDataset_1.Database := SqlitePassDatabase_1;
SqlitePassDataset_1.DatasetName := 'cars_descriptions';
Datasource1.DataSet := SqlitePassDataset_1;*)
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
SqlitePassDatabase1.Connected := False;
end;

procedure TForm1.SqlitePassDataset1CalcFields(DataSet: TDataSet);
begin
//SqlitePassDataset1Calc1.Value := 'C1 Row = '+ IntToStr(SqlitePassDataset1.RecNo);
//SqlitePassDataset1Calc2.Value := 'C2 Row = '+ IntToStr(SqlitePassDataset1.RecNo);
(*SqlitePassDataset1.DebugScreen.Lines.Add('');
SqlitePassDataset1.DebugScreen.Lines.Add('   >> TForm - CalcFields '+ IntToStr(SqlitePassDataset1.RecNo));
SqlitePassDataset1.DebugScreen.Lines.Add('');*)
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
Datasource1.DataSet.Close;
Datasource1.DataSet.Fields.Clear;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
R: Boolean;
begin
Datasource1.DataSet.Open;
SqlitePassDataset1.ReadOnly := False;
R := SqlitePassDataset1.ReadOnly;
end;

procedure TForm1.Button4Click(Sender: TObject);
var
NewField: TField;
IsOpen: Boolean;
begin
IsOpen := Datasource1.DataSet.Active;
Datasource1.DataSet.Close;

NewField := TIntegerField.Create(Datasource1.DataSet);
NewField.FieldName := 'name';
NewField.Name := 'Field_Name';
NewField.DataSet := Datasource1.DataSet;

NewField := TStringField.Create(Datasource1.DataSet);
NewField.FieldName := 'EssaiNewField_'+IntToStr(Datasource1.DataSet.Fields.Count);
NewField.DisplayWidth := 20;
NewField.FieldKind := fkCalculated;
NewField.DataSet := Datasource1.DataSet;

NewField := TStringField.Create(Datasource1.DataSet);
NewField.FieldName := 'EssaiNewField_'+IntToStr(Datasource1.DataSet.Fields.Count);
NewField.Size := 10;
NewField.Calculated := True;
NewField.DataSet := Datasource1.DataSet;
{ You don't have to use Datasource1.DataSet.Fields.Add(NewField)
  because setting NewField.Dataset will do it }
Datasource1.DataSet.Active := IsOpen;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
Datasource1.DataSet.Refresh;
end;
(*
Fields stored in dfm are always created when form is created
even if dataset is closed
*)
procedure TForm1.Button6Click(Sender: TObject);
var
F: TField;
i: Integer;
begin
{ This work only if fields are not defaultfields }
i := Pred(Datasource1.DataSet.Fields.Count);
if (i > -1) and Not Datasource1.Dataset.DefaultFields
   then begin
        F := Datasource1.DataSet.Fields[i];
        { This will close the dataset and remove the field from
          the Fieldlist and free the field }
        F.Destroy;
        Datasource1.DataSet.Open;
        end;
end;

procedure TForm1.ChangeSql1Click(Sender: TObject);
begin
SqlitePassDatabase1.Close;
SqlitePassDatabase1.Database := 'C:\MyLazarus\Components\SQLitePass\Demo\Databases\Copie (2) de Cars.kexi';
SqlitePassDatabase1.Open;
SqlitePassDataset1.DatasetName := 'cars_descriptions';
SqlitePassDataset1.Open;
end;


procedure TForm1.ChangeSql2Click(Sender: TObject);
begin
SqlitePassDatabase1.Close;
SqlitePassDatabase1.Database := 'C:\MyLazarus\Components\SQLitePass\Demo\Databases\Copie (2) de Cars.kexi';
SqlitePassDatabase1.Open;
SqlitePassDataset1.Sql.Text := 'Select * from companies;';
SqlitePassDataset1.Open;
end;

procedure TForm1.BtnFilterClick(Sender: TObject);
begin
SqlitePassDataset1.FilterRecordLowerLimit := 1;
SqlitePassDataset1.FilterRecordUpperLimit := 10;
SqlitePassDataset1.Filtered := True;
end;

procedure TForm1.BtnMasterFieldsClick(Sender: TObject);
var
F: TForm;
begin
//SqlitePassDataset2.MasterSource := DataSource1;
//SqlitePassDataset2.MasterSource.Fie

F := TSqlitePassMasterDetailDialog.Create(Self, SqlitePassDataset2);
F.ShowModal;
F.Free;
end;

procedure TForm1.BtnMasterDetailClick(Sender: TObject);
var
F: TFormMasterDetail;
begin
F := TFormMasterDetail.Create(Self);
F.ShowModal;
F.Free;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
SqlitePassDatabase1.Close;
end;

procedure TForm1.SqlitePassDataset1FilterRecord(DataSet: TDataSet;
  var Accept: Boolean);
var
i: Integer;
s: string;
begin
(*for i := 0 to Pred(Dataset.Fields.Count) do
    s := Dataset.Fields[i].AsString;
Accept := Dataset.FieldByName('company').value = 1;*)
Accept := True;
end;

procedure TForm1.BtFieldDefsInfoClick(Sender: TObject);
//var
//F: TSqlitePassFieldDefsDialog;
begin
{F := TSqlitePassFieldDefsDialog.Create(Nil, SqlitePassDataset1);
F.ShowModal;
F.Free;}
end;
procedure TForm1.BtLocateClick(Sender: TObject);
begin
SqlitePassDataset1.Locate('companycode;name',VarArrayOf(['2','Essai']),[]);
end;

procedure TForm1.Button8Click(Sender: TObject);
var
F: TSqlitePassDataTypesDlg;
begin
F := TSqlitePassDataTypesDlg.Create(Self, SqlitePassDatabase1.DatatypeOptions, SqlitePassDatabase1.DatabaseType);
F.ShowModal;
F.Free;
end;

procedure TForm1.StoreToDatabaseClick(Sender: TObject);
begin
SqlitePassDatabase1.DatatypeOptions.SaveToDatabase([soProperties, soTranslationRules, soCustomFieldDefs]);
end;

procedure TForm1.LoadFromDatabaseClick(Sender: TObject);
begin
SqlitePassDatabase1.DatatypeOptions.LoadFromDatabase([soProperties, soTranslationRules, soCustomFieldDefs]);
end;

procedure TForm1.Button9Click(Sender: TObject);
var
F: TSqlitePassCustomFieldDefsDlg;
begin
F := TSqlitePassCustomFieldDefsDlg.Create(Self, SqlitePassDatabase1.DatatypeOptions);
F.ShowModal;
F.Free;
end;

procedure TForm1.Button10Click(Sender: TObject);
begin
SqlitePassDataset1.Close;
end;

procedure TForm1.BtCreateDatabaseClick(Sender: TObject);
begin
if Not FileExists('NewDb.db3')
   then SqlitePassDatabase1.CreateDatabase('NewDb.db3');

SqlitePassDatabase1.Close;
SqlitePassDatabase1.Database := 'NewDb.db3';
SqlitePassDatabase1.Open;
SqlitePassDatabase1.TableDefs.CreateTable(
'CREATE TABLE [SampleTable] ( [AutoIncField] AUTOINC, [BinIntField] BIGINT,' +
'[BinaryField] BINARY, [BlobField] BLOB, [BooleanField] BOOLEAN, [CharField] CHAR,' +
'[ClobField] CLOB, [CurrencyField] CURRENCY, [DateField] DATE, [DateTextField] DATE,' +
'[DateTimeField] DATETIME, [DecField] DEC, [DecimalField] DECIMAL, [DoubleField] DOUBLE,' +
'[DoublePrecisionField] DOUBLE PRECISION, [FloatField] FLOAT, [GaphicField] GRAPHIC,'+
'[GuidField] GUID, [IntField] INT, [Int64Field] INT64);');
SqlitePassDataset1.DatasetName := 'SampleTable';
SqlitePassDataset1.Open;
end;

end.

        