{   This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 2.1 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   ---------------------------------------------------------------------------

    Messages localisation unit
    Author : Luc DAVID Email: luckylazarus@free.fr
    Copyright (C) 2006 - 2007

   --------------------------------------------------------------------------- }

unit SQLitePassDboTest;
 {$IFDEF FPC}
  {$mode DELPHI}
 {$ENDIF}
interface

uses

  {$IFDEF WIN32}
  Windows,
  {$ENDIF}

  {$IFDEF FPC}
  LResources,
  {$ENDIF}
  Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, DBGrids, Db, StdCtrls, ComCtrls, ExtCtrls, DBCtrls, SqlitePassDbo,
  ExtDlgs, ActnList, Menus, Buttons, ImgList, SqlitePassUtils;


type

  { TMainForm }

  TMainForm = class(TForm)
    Tv: TTreeView;
    StatusBar: TStatusBar;
    PanelDatabaseToolBar: TPanel;
    Panel2: TPanel;
    PageControl: TPageControl;
    TsDatabase: TTabSheet;
    TsDataset: TTabSheet;
    DataSource: TDataSource;
    OpenPictureDialog: TOpenPictureDialog;
    SavePictureDialog: TSavePictureDialog;
    MainMenu: TMainMenu;
    MainActionList: TActionList;
    ActionApplicationQuit: TAction;
    OpenFileDialog: TOpenDialog;
    Database: TMenuItem;
    Open1: TMenuItem;
    Close1: TMenuItem;
    MenuSeparator1: TMenuItem;
    Quit1: TMenuItem;
    SaveFileDialog: TSaveDialog;
    LabelCacheSize: TLabel;
    EditDbCacheSize: TEdit;
    Label1: TLabel;
    LabelDbType: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Bevel2: TBevel;
    Label5: TLabel;
    LabelDbFileSize: TLabel;
    Label6: TLabel;
    EditDbQueryTimeout: TEdit;
    CbDbReadOnly: TCheckBox;
    CbDbShowSystemObjects: TCheckBox;
    CBDbSmartOpen: TCheckBox;
    Label8: TLabel;
    EditDbUserTag: TEdit;
    Label7: TLabel;
    Bevel3: TBevel;
    Label9: TLabel;
    LabelDbComponentVersion: TLabel;
    Label11: TLabel;
    LabelDbSqliteLibVersion: TLabel;
    Label13: TLabel;
    LabelDbVersion: TLabel;
    Label15: TLabel;
    LabelDbKexiVersion: TLabel;
    Label10: TLabel;
    EditDbDefaultCacheSize: TEdit;
    CbDbAutoVacuum: TCheckBox;
    CbDbCountChanges: TCheckBox;
    CbDbCaseSensitiveLike: TCheckBox;
    CbDbEmptyResultCallback: TCheckBox;
    CbDbFullColumnName: TCheckBox;
    Label12: TLabel;
    EditDbPageSize: TEdit;
    Label14: TLabel;
    EditDbEncoding: TEdit;
    Bevel4: TBevel;
    Panel5: TPanel;
    SbDbApplyChanges: TSpeedButton;
    SbDbCancelChanges: TSpeedButton;
    Label17: TLabel;
    EditDbTemporaryStorage: TEdit;
    Label18: TLabel;
    Label19: TLabel;
    EditDbSynchronous: TEdit;
    TsSQL: TTabSheet;
    sbRefreshDatabaseInfos: TSpeedButton;
    PageControlDataset: TPageControl;
    TsDatasetStructure: TTabSheet;
    PanelFieldDefs: TPanel;
    Label16: TLabel;
    PanelSqlSelectStatement: TPanel;
    Label2: TLabel;
    PanelSqlCreateStmt: TPanel;
    TsDatasetData: TTabSheet;
    Panel3: TPanel;
    DBImage: TDBImage;
    BtLoadPictureFromFile: TButton;
    BtClearPicture: TButton;
    BtSavePictureToFile: TButton;
    DBMemo: TDBMemo;
    ComboBoxGraphicFields: TComboBox;
    CbShowGraphic: TCheckBox;
    CbShowMemo: TCheckBox;
    BtLoadMemoFromFile: TButton;
    BtClearMemo: TButton;
    BtSaveMemoToFile: TButton;
    ComboBoxMemoFields: TComboBox;
    PanelNoRecordFound: TPanel;
    DBGridDatasetData: TDBGrid;
    TsDatasetTest: TTabSheet;
    Panel4: TPanel;
    LabelRecordCountToAppend: TLabel;
    SbAppendRecords: TButton;
    EditRecordCount: TEdit;
    CheckBoxUseTransaction: TCheckBox;
    MemoDebug: TMemo;
    Label20: TLabel;
    Help1: TMenuItem;
    ActionApplicationShowAbout: TAction;
    ActionShowAbout1: TMenuItem;
    CreateaNewdatabase1: TMenuItem;
    N1: TMenuItem;
    Refreshdatabaseinformation1: TMenuItem;
    Compactsize1: TMenuItem;
    CheckdatabaseIntegrity1: TMenuItem;
    N2: TMenuItem;
    StartTransaction1: TMenuItem;
    CommitTransaction1: TMenuItem;
    RollbackTransaction1: TMenuItem;
    TsDatasetIndexes: TTabSheet;
    PanelIndexesToolBar: TPanel;
    PanelIndexMain: TPanel;
    PanelAvailableIndexes: TPanel;
    LabelIndexAvailable: TLabel;
    ListBoxIndexDefs: TListBox;
    PanelIndexRight: TPanel;
    MemoSQLIndexCreateStmt: TMemo;
    ScrollBoxIndexedFields: TScrollBox;
    PanelFieldsUsedByIndex: TPanel;
    Splitter1: TSplitter;
    LabelIndexFieldsUsed: TLabel;
    PanelIndexApplyChanges: TPanel;
    SbApplyIndexChanges: TSpeedButton;
    SbCancelIndexChanges: TSpeedButton;
    PanelIndexCreateStmt: TPanel;
    Label21: TLabel;
    Image4: TImage;
    Image5: TImage;
    MemoSqlCreateStmt: TMemo;
    MemoSqlSelectStmt: TMemo;
    Image6: TImage;
    Image8: TImage;
    Image9: TImage;
    Panel1: TPanel;
    Label22: TLabel;
    Image10: TImage;
    ImageIndexDirectionDesc: TImage;
    ImageIndexDirectionAsc: TImage;
    ImageIndexDirectionUnknown: TImage;
    ActionListDatabase: TActionList;
    ActionDatabaseCreateNew: TAction;
    ActionDatabaseOpen: TAction;
    ActionDatabaseRefresh: TAction;
    ActionDatabaseClose: TAction;
    ActionDatabaseAttach: TAction;
    ActionDatabaseCheckIntegrity: TAction;
    ActionDatabaseCompactSize: TAction;
    ActionListIndexes: TActionList;
    ActionIndexCreateNew: TAction;
    ActionIndexRename: TAction;
    ActionIndexDelete: TAction;
    ActionIndexRefresh: TAction;
    PanelSqlStmt: TPanel;
    PanelSqlResult: TPanel;
    Splitter2: TSplitter;
    Panel6: TPanel;
    Label23: TLabel;
    Image1: TImage;
    Panel7: TPanel;
    Label24: TLabel;
    Image2: TImage;
    Panel8: TPanel;
    SbRunSQL: TSpeedButton;
    MemoSqlStmt: TMemo;
    ActionSQL: TAction;
    ActionDatabaseTransactionStart: TAction;
    ActionDatabaseTransactionCommit: TAction;
    ActionDatabaseTransactionRollback: TAction;
    DBGridSqlDirect: TDBGrid;
    DBNavigator2: TDBNavigator;
    DsSQLDirect: TDataSource;
    ActionDatabaseDetach: TAction;
    Attachadatabase1: TMenuItem;
    Detachadatabase1: TMenuItem;
    N3: TMenuItem;
    Action1: TAction;
    Action2: TAction;
    Action3: TAction;
    Action4: TAction;
    Panel9: TPanel;
    DBNavDataset: TDBNavigator;
    ImageDatasetReadOnly: TImage;
    LabelDatasetReadOnly: TLabel;
    Label25: TLabel;
    Bevel1: TBevel;
    Label26: TLabel;
    GridAttachedDatabases: TStringGrid;
    Splitter: TSplitter;
    ImageListDisabled: TImageList;
    ImageListEnabled: TImageList;
    SbParseSql: TSpeedButton;
    PanelDatasetToolbar: TPanel;
    ActionListDataset: TActionList;
    ActionDatasetSort: TAction;
    CheckBoxUniqueIndex: TCheckBox;
    Image7: TImage;
    ComboBoxSQLStmts: TComboBox;
    ImageCheck: TImage;
    Image11: TImage;
    Panel31: TPanel;
    Panel10: TPanel;
    ScrollBarVertical: TScrollBar;
    ScrollBarHorizontal: TScrollBar;
    ScrollBoxFieldDefsPropertiesValues: TScrollBox;
    Panel32: TPanel;
    ScrollboxFieldDefsFieldNames: TScrollBox;
    Panel33: TPanel;
    ScrollBoxFieldDefsPropertiesNames: TScrollBox;
    Panel11: TPanel;
    Panel12: TPanel;
    Panel13: TPanel;
    Panel14: TPanel;
    Panel15: TPanel;
    Panel30: TPanel;
    Panel16: TPanel;
    Panel17: TPanel;
    Panel18: TPanel;
    Panel19: TPanel;
    Panel20: TPanel;
    Panel22: TPanel;
    Panel23: TPanel;
    Panel24: TPanel;
    Panel25: TPanel;
    Panel26: TPanel;
    Panel27: TPanel;
    Panel28: TPanel;
    Panel29: TPanel;
    ActionDatasetFilterOnSelection: TAction;
    procedure FormCreate(Sender: TObject);
    procedure TvChange(Sender: TObject; Node: TTreeNode);
    procedure SbAppendRecordsClick(Sender: TObject);
    procedure BtLoadPictureFromFileClick(Sender: TObject);
    procedure BtClearPictureClick(Sender: TObject);
    procedure BtSavePictureToFileClick(Sender: TObject);
    procedure ActionDatabaseOpenExecute(Sender: TObject);
    procedure CbShowGraphicClick(Sender: TObject);
    procedure CbShowMemoClick(Sender: TObject);
    procedure BtLoadMemoFromFileClick(Sender: TObject);
    procedure BtClearMemoClick(Sender: TObject);
    procedure BtSaveMemoToFileClick(Sender: TObject);
    procedure ComboBoxGraphicFieldsChange(Sender: TObject);
    procedure ActionDatabaseCloseExecute(Sender: TObject);
    procedure DbSettingChanged(Sender: TObject);
    procedure SbDbApplyChangesClick(Sender: TObject);
    procedure SbDbCancelChangesClick(Sender: TObject);
    procedure ActionApplicationQuitExecute(Sender: TObject);
    procedure ActionDatabaseRefreshExecute(Sender: TObject);
    procedure ListBoxIndexDefsClick(Sender: TObject);
    procedure ActionApplicationShowAboutExecute(Sender: TObject);
    procedure ActionDatabaseCompactSizeExecute(Sender: TObject);
    procedure ActionIndexCreateNewExecute(Sender: TObject);
    procedure ActionIndexDeleteExecute(Sender: TObject);
    procedure ActionIndexRefreshExecute(Sender: TObject);
    procedure ActionSQLExecute(Sender: TObject);
    procedure SbRunSQLClick(Sender: TObject);
    procedure ActionDatabaseTransactionStartExecute(Sender: TObject);
    procedure ActionDatabaseTransactionCommitExecute(Sender: TObject);
    procedure ActionDatabaseTransactionRollbackExecute(Sender: TObject);
    procedure ActionIndexRenameExecute(Sender: TObject);
    procedure ActionDatabaseAttachExecute(Sender: TObject);
    procedure ActionDatabaseDetachExecute(Sender: TObject);
    procedure MainActionListUpdate(anAction: TBasicAction;
      var Handled: Boolean);
    procedure DBGridDatasetDataTitleClick(Column: TColumn);
    procedure SbParseSqlClick(Sender: TObject);
    procedure ActionDatasetSortExecute(Sender: TObject);
    procedure PanelIndexesToolBarMouseMove(Sender: TObject;
      Shift: TShiftState; X, Y: Integer);
    procedure ComboBoxMemoFieldsChange(Sender: TObject);
    procedure TsDatasetIndexesShow(Sender: TObject);
    procedure SbCancelIndexChangesClick(Sender: TObject);
    procedure CheckBoxUniqueIndexClick(Sender: TObject);
    procedure ComboBoxSQLStmtsChange(Sender: TObject);
    procedure TsSQLShow(Sender: TObject);
    procedure ScrollBarVerticalScroll(Sender: TObject;
      ScrollCode: TScrollCode; var ScrollPos: Integer);
    procedure ScrollBoxFieldDefsPropertiesValuesResize(Sender: TObject);
    procedure ScrollBarHorizontalScroll(Sender: TObject;
      ScrollCode: TScrollCode; var ScrollPos: Integer);
    procedure FormDestroy(Sender: TObject);
    procedure ActionDatasetFilterOnSelectionExecute(Sender: TObject);
    procedure ActionDatasetFilterOnSelectionUpdate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    MRUFileList: TStringList;

    Procedure ResfreshMenu;
    Procedure RefreshStatusBar;
    procedure RefreshActionListDatabase(Enable: Boolean);
    procedure RefreshTreeView;
    { --- Indexes --- }
    procedure RefreshIndexList;
    procedure RefreshIndexInfos(CurrentIndex: TSqlitePassIndex);
    procedure RefreshIndexSpeedButtons(Enable: Boolean);
    procedure OnCbIndexedFieldClick(Sender: TObject);
    procedure OnImIndexDirectionClick(Sender: TObject);
    { --- Database --- }
    procedure OpenDatabaseFile(FileName: String = '');
    procedure ShowDatabaseInfos;
    function DatabaseTypeAsString: String;
    { --- Datasets --- }
    procedure ShowDatasetInfos(Node: TTreeNode);
    { MRU Files }
    procedure LoadMRUFiles;
    procedure SaveMRUFiles;
    procedure AddNewMRUFile(FileName: String);
    procedure MRUFileOpen(Sender: TObject);
    procedure UpdateMRUFiles;
    { --- Utility procedures to mimic Toolbars --- }
    procedure InitToolBar(ToolBar: TPanel; ActionList: TActionList);
    procedure RefreshToolBar(ToolBar: TPanel; RefreshAll: Boolean);
    procedure OnToolBarMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure OnToolBarBtnMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure Internal_OnToolBarBtnMouseMove(ToolBar: TPanel; Im: TImage);
    procedure OnToolBarBtnClick(Sender: TObject);
    procedure Internal_OnToolBarBtnClick(Im: TImage);
    procedure DrawActionBitmap(aBitmap: TBitmap; ImageIndex: Integer; Menu, Enabled: Boolean);
  public
    { Db and Dataset selected by user }
    Db: TSqlitePassDatabase;
    Dataset: TSqlitePassDataset;

    { Dataset used to execute direct SQL on user demand }
    SQLDirectDataset: TSqlitePassDataset;

    { Db and Dataset to store program settings }
    DbSettings: TSqlitePassDatabase;
    DatasetSettings: TSqlitePassDataset;


    { TList to display Indexes information }
    CbIndexedFields: TList;
    ImIndexDirection: TList;
    { TList to display FieldDefs information }
    ListofPanelFieldDefProperties: TList;
    ListofPanelFieldDefFieldNames: TList;

    DatabaseNode, TablesNode, QueriesNode, ViewsNode, TriggersNode, SystemTablesNode, SQLNode: TTreeNode;
  end;


  { Panels to display FieldDefs information }
  TPanelFieldDefPropertiesValues = class;

  TPanelFieldDefPropertyValue = Class(TPanel)
  Public
  constructor Create(AOwner: TPanel); reintroduce;
  constructor CreateAtPos(AOwner: TPanel; Top, Left: Integer); virtual;
  end;

  TPanelFieldDefTitle = Class(TPanel)
  Public
  constructor Create(AOwner: TComponent); Reintroduce;
  constructor CreateAtPos(AOwner: TComponent; Top, Left: Integer); virtual;
  end;


  TPanelFieldDefBooleanPropertyValue = Class(TPanelFieldDefPropertyValue)
  Private
  FImage: TImage;
    FValue: Boolean;
    procedure SetFValue(const Value: Boolean);
  Public
  Property Value: Boolean Read FValue Write SetFValue;
  constructor CreateAtPos(AOwner: TPanelFieldDefPropertiesValues; Top, Left: Integer); reintroduce;
  destructor Destroy; Override;
  end;

  TPanelFieldDefPropertiesValues = Class(TPanel)
  Private
  FLeft: Integer;
  Protected
  FTop: Integer;
  FVOffset: Integer;
  FDataType: TPanelFieldDefPropertyValue;
  FAutoInc: TPanelFieldDefBooleanPropertyValue;
  FDefaultValue: TPanelFieldDefPropertyValue;
  FDisplayName: TPanelFieldDefPropertyValue;
  FFieldNo: TPanelFieldDefPropertyValue;
  FFieldFullName: TPanelFieldDefPropertyValue;
  FForeignKey: TPanelFieldDefBooleanPropertyValue;
  FHint: TPanelFieldDefPropertyValue;
  FIndexed: TPanelFieldDefBooleanPropertyValue;
  FInternalPrimaryKey: TPanelFieldDefBooleanPropertyValue;
  FNativeDataType: TPanelFieldDefPropertyValue;
  FNativeDataTypeCode: TPanelFieldDefPropertyValue;
  FNotEmpty: TPanelFieldDefBooleanPropertyValue;
  FNoConstraints: TPanelFieldDefBooleanPropertyValue;
  FNotNull: TPanelFieldDefBooleanPropertyValue;
  FPrecision: TPanelFieldDefPropertyValue;
  FPrimaryKey: TPanelFieldDefBooleanPropertyValue;
  FSize: TPanelFieldDefPropertyValue;
  FUnique: TPanelFieldDefBooleanPropertyValue;
  public
  constructor Create(AOwner: TComponent); override;
  constructor CreateAtPos(AOwner: TComponent; Top, Left: Integer);
  destructor Destroy; Override;
  end;

const
  MaxMRUFilesCount = 6;
var
  MainForm: TMainForm;

implementation

 {$IFNDEF FPC}
  {$R *.DFM}
 {$ENDIF}
Uses SqlitePassSortByDialog, CreateNewIndex, RenameItem;


{ Creates / Destroys the Main Form }

procedure TMainForm.FormCreate(Sender: TObject);
begin
CbIndexedFields:= TList.Create;
ImIndexDirection:= TList.Create;
ListofPanelFieldDefProperties := TList.Create;
ListofPanelFieldDefFieldNames := TList.Create;
InitToolBar(PanelDatabaseToolBar, ActionListDatabase);
InitToolBar(PanelIndexesToolBar, ActionListIndexes);
InitToolbar(PanelDatasetToolBar, ActionListDataset);

{ Db and Dataset to store program settings }
DbSettings := TSqlitePassDatabase.Create(Self);
DbSettings.Database := 'SqlitePassToolBox.db3';
DatasetSettings := TSqlitePassDataset.Create(Self);
DatasetSettings.Database := DbSettings;

{ Db and Dataset selected by user }
Db := TSqlitePassDatabase.Create(Self);
Dataset := TSqlitePassDataset.Create(Self);
Dataset.Database := Db;

{ Dataset used to execute direct SQL on user demand }
SQLDirectDataset := TSqlitePassDataset.Create(Self);
SQLDirectDataset.Database := Db;
SQLDirectDataset.ReadOnly := False;
dsSQLDirect.DataSet := SQLDirectDataset;

{ MRU Files }
MRUFileList := TStringList.Create;
LoadMRUFiles;

{ Reset Toolbars etc...}
ActionDatabaseCloseExecute(Self);
TvChange(MainForm,  nil);
RefreshStatusBar;

(*ScrollbarVertical.Min := 0;
ScrollbarVertical.Max := ScrollBoxFieldDefsPropertiesValues.Height;
ScrollbarHorizontal.Min := 0;
ScrollbarHorizontal.Max := ScrollBoxFieldDefsPropertiesValues.Width;*)

end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
{ No need to free Db or datasets since the owner will do it automatically }
CbIndexedFields.Free;
ImIndexDirection.Free;
ListofPanelFieldDefProperties.Free;
ListofPanelFieldDefFieldNames.Free;
MRUFileList.Free;
end;

{ Terminates the application }

procedure TMainForm.ActionApplicationQuitExecute(Sender: TObject);
begin
Application.Terminate;
end;

{ Opens / Closes a database }

procedure TMainForm.ActionDatabaseOpenExecute(Sender: TObject);
begin
OpenDatabaseFile;
end;

procedure TMainForm.OpenDatabaseFile(FileName: String = '');
begin
if (FileName = '') then
   if OpenFileDialog.Execute and (OpenFileDialog.FileName <> '')
      then FileName := OpenFileDialog.FileName
      else exit;

if FileName <> '' then
   begin
   Db.Close;
   Db.Database := FileName;
   Db.Open;
   AddNewMRUFile(Db.Database);
   UpdateMRUFiles;
   RefreshTreeview;
   RefreshActionListDatabase(True);
   end;
end;

procedure TMainForm.ActionDatabaseCloseExecute(Sender: TObject);
begin
Db.Close;
Tv.Items.Clear;
TvChange(MainForm,  nil);
RefreshActionListDatabase(False);
RefreshStatusBar;
end;

{ Displays Databases parts in a Treeview }

procedure TMainForm.TvChange(Sender: TObject; Node: TTreeNode);
var
i : Integer;
begin
// TCustomNoteBook.visible := True raises exception with Lazarus so we skip it until it is solved...
{$IFNDEF FPC}
{ Database is closed ? }
if Node = nil
   then begin
   for i := 0 to Pred(PageControl.PageCount)
    do PageControl.Pages[i].TabVisible := False;
   exit;
   end;

{ Database }
if Node = DatabaseNode
   then begin
   ShowDatabaseInfos;
   PageControl.Pages[0].Tabvisible := True;
   PageControl.Pages[1].Tabvisible := False;
   PageControl.Pages[2].Tabvisible := False;
   end;


if Node.Parent = nil then exit;

{ Datasets }
if ((Node.Parent = TablesNode) or (Node.Parent = SystemTablesNode)
     or (Node.Parent = QueriesNode) or (Node.Parent = ViewsNode))
     then begin
     ShowDatasetInfos(Node);
     PageControl.Pages[0].Tabvisible := False;
     PageControl.Pages[1].Tabvisible := True;
     PageControl.Pages[2].Tabvisible := False;
     PageControlDataset.Pages[2].Tabvisible := (Node.Parent <> QueriesNode)
                                                and (Node.Parent <> ViewsNode);
     end;

{ SQL Execute }
if Node = SQLNode
   then begin
   PageControl.Pages[0].Tabvisible := False;
   PageControl.Pages[1].Tabvisible := False;
   PageControl.Pages[2].Tabvisible := True;
   end;
{$ELSE}
if Node = nil then exit;

{ Database }
if Node = DatabaseNode
   then ShowDatabaseInfos;

if Node.Parent = nil then exit;

{ Datasets }
if ((Node.Parent = TablesNode) or (Node.Parent = SystemTablesNode)
     or (Node.Parent = QueriesNode) or (Node.Parent = ViewsNode))
     then ShowDatasetInfos(Node);

{$ENDIF}
end;


{ Displays infos on current database }

procedure TMainForm.ActionDatabaseRefreshExecute(Sender: TObject);
var
i: integer;
f: TFileStream;
begin
if not Db.Connected then exit;
Db.RefreshDefinitions;
Tv.Selected := DatabaseNode;

LabelDbType.Caption := DatabaseTypeAsString;

{ file size }
f := TFileStream.Create(Db.Database, fmOpenRead or fmShareDenyNone);;
LabelDbFileSize.Caption := IntToStr(F.Size) + ' octets';
{ Cache Size }
EditDbCacheSize.Text := IntToStr(Db.Options.CacheSize);
{ Query Timeout }
EditDbQueryTimeout.Text := IntToStr(Db.QueryTimeout);
{ User Tag }
EditDbUserTag.Text := IntToStr(Db.UserTag);
{ Read Only }
CbDbReadOnly.Checked := Db.ReadOnly;
{ Show System Objects }
CbDbShowSystemObjects.Checked := Db.ShowSystemObjects;
{ Smart Open }
CbDbSmartOpen.Checked := Db.SmartOpen;
{ Auto Vacuum }
CbDbAutoVacuum.Checked := Db.Options.AutoVacuum;
{ Count Changes }
CbDbCountChanges.Checked := Db.Options.CountChanges;
{ Case Sensitive "Like" }
CbDbCaseSensitiveLike.Checked := Db.Options.CaseSensitiveLike;
{ Empty Result Callback }
CbDbEmptyResultCallback.Checked := Db.Options.EmptyResultCallback;
{ Full Column Name }
CbDbFullColumnName.Checked := Db.Options.FullColumnNames;
{ Page Size }
EditDbCacheSize.Text := IntToStr(Db.Options.PageSize);
{ Encoding }

// TODO - add TComboListBox
EditDbEncoding.Text := '';
{ Temporary Storage }
EditDbTemporaryStorage.Text := '';
{ Synchronous }

{ ComponentVersion }
LabelDbComponentVersion.Caption := Db.VersionInfo.Component;
{ Sqlite Library Version }
LabelDbSqliteLibVersion.Caption := Db.VersionInfo.SqliteLibrary;
{ Database Version }
LabelDbVersion.Caption := IntToStr(Db.VersionInfo.Schema);
{ Database created with Kexi version }
LabelDbKexiVersion.Caption := Db.VersionInfo.DbVersion;

{ --- Display Attached Databases Infos ---  }
With GridAttachedDatabases do
  begin
  cells[0,0] := 'Alias name';
  cells[1,0] := 'Database';
  { Clear Grid }
  for i := 1 to 9 do  // should be 1 to 10 -> Lazarus TVirtualGrid.GetCells(Col, Row: Integer) bug ?
    begin
    Cells[0,i] := '';
    Cells[1,i] := '';
    end;
  { Refresh Grid }
  if (Db.Databases.count > 0) then
  begin
  for i := 0 to Pred(Db.Databases.count) do
    begin
    Cells[0,i+1] := Db.Databases[i].AliasName;
    Cells[1,i+1] := Db.Databases[i].Database;
    end;
  end;
  end;
  ActionDatabaseDetach.Enabled := (GridAttachedDatabases.Cells[0,GridAttachedDatabases.row] <> '');
  RefreshToolBar(PanelDatabaseToolBar,True);
end;

procedure TMainForm.ActionDatabaseCompactSizeExecute(Sender: TObject);
begin
ShowMessage(IntToStr(Db.Compact) + ' octets have been freed from the database : '+ Db.Database);
end;


{ Displays infos on Status Bar }

procedure TMainForm.RefreshStatusBar;
begin
With StatusBar do
     begin
     if Db.Connected
        then begin
             Panels[0].Text := ' Sqlite Engine : ' + Db.VersionInfo.SqliteLibrary;
             Panels[1].Text := ' Database : ' + Db.Database;
             Panels[2].Text := ' Database type : ' + DatabaseTypeAsString;
             if Dataset.Active
                then begin
                Panels[3].Text := ' Records count : ' + IntToStr(Dataset.RecordCount);
                Panels[4].Text := ' Elapsed Time : ' + FloatToStr(Dataset.Database.Engine.ElapsedTime);
                end;
              end
        else begin // Db is not Connected
             Panels[0].Text := ' Sqlite Engine : Unknown...';
             Panels[1].Text := ' Database : Unknown...';
             Panels[2].Text := ' Database type : Unknown...';
             Panels[3].Text := ' Records count : Unknown...';
             Panels[4].Text := ' Elapsed Time : Unknown...';
             end;
     end;
end;


{ Loads / Shows / Saves images (Blobs) }

procedure TMainForm.BtLoadPictureFromFileClick(Sender: TObject);
begin
if OpenPictureDialog.Execute
   then begin
        Dataset.Edit;
        TBlobField(DbImage.Field).LoadFromFile(OpenPictureDialog.Filename);
        end;
end;

procedure TMainForm.BtClearPictureClick(Sender: TObject);
begin
 Dataset.Edit;
 DbImage.Field.Clear;
end;

procedure TMainForm.BtSavePictureToFileClick(Sender: TObject);
begin
If SavePictureDialog.Execute
   then TBlobField(DbImage.Field).SaveToFile(SavePictureDialog.Filename);
end;

procedure TMainForm.CbShowGraphicClick(Sender: TObject);
begin
if cbShowGraphic.Checked
 then ComboBoxGraphicFieldsChange(Sender);
end;

procedure TMainForm.ComboBoxGraphicFieldsChange(Sender: TObject);
var
F: TField;
begin
if ComboBoxGraphicFields.Text = '' then exit;
F := Dataset.FieldByName(ComboBoxGraphicFields.Text);
if (F <> nil) and CbShowGraphic.Checked
   then begin
        if F.DataType in [ftBlob, ftGraphic]
           then DbImage.DataField := ComboBoxGraphicFields.Text;
        end
        else DbImage.DataField := '';
end;


{ Loads / Shows / Saves Memos (Blobs) }

procedure TMainForm.CbShowMemoClick(Sender: TObject);
begin
if cbShowMemo.Checked
   then ComboBoxMemoFieldsChange(Sender);
end;

procedure TMainForm.BtLoadMemoFromFileClick(Sender: TObject);
begin
if OpenFileDialog.Execute
   then begin
        Dataset.Edit;
        TMemoField(DbMemo.Field).LoadFromFile(OpenFileDialog.FileName);
        end;
end;

procedure TMainForm.BtClearMemoClick(Sender: TObject);
begin
 Dataset.Edit;
 TBlobField(DbMemo.Field).Clear;
 Dataset.Post;
end;

procedure TMainForm.BtSaveMemoToFileClick(Sender: TObject);
begin
If SaveFileDialog.Execute
   then TBlobField(DbMemo.Field).SaveToFile(SaveFileDialog.Filename);
end;


procedure TMainForm.DbSettingChanged(Sender: TObject);
begin
// TODO
end;

procedure TMainForm.SbDbApplyChangesClick(Sender: TObject);
begin
// TODO
end;

procedure TMainForm.SbDbCancelChangesClick(Sender: TObject);
begin
// TODO;
end;


procedure TMainForm.ListBoxIndexDefsClick(Sender: TObject);
begin
RefreshIndexInfos(Db.IndexDefs.FindIndex(ListBoxIndexDefs.Items[ListBoxIndexDefs.ItemIndex]));
end;

procedure TMainForm.ActionApplicationShowAboutExecute(Sender: TObject);
begin
ShowMessage('SQLiteToolBox. SQLitePass Components Demo Program. Version : '+ Db.VersionInfo.Component);
end;


{ Utility procedures to mimic simple Toolbars... }
procedure TMainForm.OnToolBarBtnMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
Internal_OnToolBarBtnMouseMove(TPanel(TImage(Sender).Parent), TImage(Sender));
end;

procedure TMainForm.OnToolBarBtnClick(Sender: TObject);
begin
Internal_OnToolBarBtnClick(TImage(Sender));
end;

procedure TMainForm.OnToolBarMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
RefreshToolBar(TPanel(Sender), True);
end;

{ ToolBar End }

procedure TMainForm.ActionSQLExecute(Sender: TObject);
begin
Tv.Selected := SQLNode;
end;

procedure TMainForm.SbParseSqlClick(Sender: TObject);
begin
SQLDirectDataset.Close;
SQLDirectDataset.SQL.Assign(MemoSqlStmt.Lines);
SQLDirectDataset.SQLSelectStmt.Prepare(SQLDirectDataset.SQL.Text);
MemoSqlStmt.Lines.Assign(SQLDirectDataset.SQLSelectStmt.SQL);
end;

procedure TMainForm.SbRunSQLClick(Sender: TObject);
begin
SbParseSqlClick(Sender);
SQLDirectDataset.Open;
end;

procedure TMainForm.ActionDatabaseTransactionStartExecute(Sender: TObject);
begin
Db.Engine.Transaction.Start;
ActionDatabaseTransactionStart.Enabled := False;
ActionDatabaseTransactionCommit.Enabled := True;
ActionDatabaseTransactionRollback.Enabled := True;
RefreshToolBar(PanelDatabaseToolBar,True);
end;

procedure TMainForm.ActionDatabaseTransactionCommitExecute(
  Sender: TObject);
begin
Db.Engine.Transaction.Commit;
ActionDatabaseTransactionStart.Enabled := True;
ActionDatabaseTransactionCommit.Enabled := False;
ActionDatabaseTransactionRollback.Enabled := False;
RefreshToolBar(PanelDatabaseToolBar,True);
end;

procedure TMainForm.ActionDatabaseTransactionRollbackExecute(
  Sender: TObject);
begin
Db.Engine.Transaction.Rollback;
ActionDatabaseTransactionStart.Enabled := True;
ActionDatabaseTransactionCommit.Enabled := False;
ActionDatabaseTransactionRollback.Enabled := False;
RefreshToolBar(PanelDatabaseToolBar,True);
end;

procedure TMainForm.ActionDatabaseAttachExecute(Sender: TObject);
begin
if OpenFileDialog.Execute
   then Db.AttachDatabase(OpenFileDialog.FileName,'');
RefreshTreeview;
ShowDatabaseInfos;
end;

procedure TMainForm.ActionDatabaseDetachExecute(Sender: TObject);
begin
Db.DetachDatabase(GridAttachedDatabases.Cells[0,GridAttachedDatabases.row]);
RefreshTreeview;
ShowDatabaseInfos;
end;


procedure TMainForm.MainActionListUpdate(anAction: TBasicAction;
  var Handled: Boolean);
begin
ResfreshMenu;
end;

procedure TMainForm.DBGridDatasetDataTitleClick(Column: TColumn);
var
i, SortPos: Integer;
SortDirection: String;

begin
For i := 0 to Pred(DBGridDatasetData.Columns.Count)
    do DBGridDatasetData.Columns[i].Title.Font.Color := clBlack;

SortDirection := ' ASC';
SortPos := Pos('<Asc> ', Column.Title.Caption);
if SortPos > 0
   then SortDirection := ' DESC'
   else begin
        SortPos := Pos('<Desc> ', Column.Title.Caption);
        if SortPos > 0 then SortDirection := ' ASC';
        end;
Column.Title.Caption := StringReplace(Column.Title.Caption, '<Asc> ', '', []);
Column.Title.Caption := StringReplace(Column.Title.Caption, '<Desc> ', '', []);
if SortDirection = ' ASC'
   then Column.Title.Caption := '<Asc> ' + Column.Title.Caption
   else Column.Title.Caption := '<Desc> ' + Column.Title.Caption;

For i := 0 to Pred(DBGridDatasetData.Columns.Count)
    do if DBGridDatasetData.Columns[i] <> Column then
          begin
          DBGridDatasetData.Columns[i].Title.Caption := StringReplace(DBGridDatasetData.Columns[i].Title.Caption, '<Asc> ', '', []);
          DBGridDatasetData.Columns[i].Title.Caption := StringReplace(DBGridDatasetData.Columns[i].Title.Caption, '<Desc> ', '', []);
          end;

Column.Title.Font.Color := clRed;
Dataset.Sorted := True;
Dataset.SortedBy := '"' + Column.FieldName + '" ' + SortDirection;
Dataset.Sort;
end;

procedure TMainForm.ActionDatasetSortExecute(Sender: TObject);
var
i: integer;
F: TSqlitePassSortedByDialog;
begin
F := TSqlitePassSortedByDialog.Create(Self, Dataset.SortedBy, Dataset.Fields);
F.ShowModal;
if F.ModalResult = mrOk then
   begin
   For i := 0 to Pred(DBGridDatasetData.Columns.Count)
       do DBGridDatasetData.Columns[i].Title.Font.Color := clBlack;
   Dataset.Sorted := True;
   Dataset.SortedBy := F.SQL;
   Dataset.Sort;
   end;
F.Free;
end;

procedure TMainForm.PanelIndexesToolBarMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
//
end;

procedure TMainForm.ShowDatabaseInfos;
var
i: integer;
f: TFileStream;
begin
if not Db.Connected then exit;
Tv.Selected := DatabaseNode;

{ file size }
f := TFileStream.Create(Db.Database, fmOpenRead or fmShareDenyNone);;
LabelDbFileSize.Caption := IntToStr(F.Size) + ' octets';
f.free;
{ Cache Size }
EditDbCacheSize.Text := IntToStr(Db.Options.CacheSize);
{ Query Timeout }
EditDbQueryTimeout.Text := IntToStr(Db.QueryTimeout);
{ User Tag }
EditDbUserTag.Text := IntToStr(Db.UserTag);
{ Read Only }
CbDbReadOnly.Checked := Db.ReadOnly;
{ Show System Objects }
CbDbShowSystemObjects.Checked := Db.ShowSystemObjects;
{ Smart Open }
CbDbSmartOpen.Checked := Db.SmartOpen;
{ Auto Vacuum }
CbDbAutoVacuum.Checked := Db.Options.AutoVacuum;
{ Count Changes }
CbDbCountChanges.Checked := Db.Options.CountChanges;
{ Case Sensitive "Like" }
CbDbCaseSensitiveLike.Checked := Db.Options.CaseSensitiveLike;
{ Empty Result Callback }
CbDbEmptyResultCallback.Checked := Db.Options.EmptyResultCallback;
{ Full Column Name }
CbDbFullColumnName.Checked := Db.Options.FullColumnNames;
{ Page Size }
EditDbCacheSize.Text := IntToStr(Db.Options.PageSize);
{ Encoding }

// TODO - add TComboListBox
EditDbEncoding.Text := '';
{ Temporary Storage }
EditDbTemporaryStorage.Text := '';
{ Synchronous }

{ ComponentVersion }
LabelDbComponentVersion.Caption := Db.VersionInfo.Component;
{ Sqlite Library Version }
LabelDbSqliteLibVersion.Caption := Db.VersionInfo.SqliteLibrary;
{ Database Version }
LabelDbVersion.Caption := IntToStr(Db.VersionInfo.Schema);
{ Database created with Kexi version }
LabelDbKexiVersion.Caption := Db.VersionInfo.DbVersion;

{ --- Display Attached Databases Infos ---  }
With GridAttachedDatabases do
  begin
  cells[0,0] := 'Alias name';
  cells[1,0] := 'Database';
  { Clear Grid }
  for i := 1 to 9 do  // should be 1 to 10 -> Lazarus TVirtualGrid.GetCells(Col, Row: Integer) bug ?
    begin
    Cells[0,i] := '';
    Cells[1,i] := '';
    end;
  { Refresh Grid }
  if (Db.Databases.count > 0) then
  begin
  for i := 0 to Pred(Db.Databases.count) do
    begin
    Cells[0,i+1] := Db.Databases[i].AliasName;
    Cells[1,i+1] := Db.Databases[i].Database;
    end;
  end;
  end;
  ActionDatabaseDetach.Enabled := (GridAttachedDatabases.Cells[0,GridAttachedDatabases.row] <> '');
  RefreshToolBar(PanelDatabaseToolBar,True);
end;


procedure TMainForm.ShowDatasetInfos(Node: TTreeNode);
var
//i, j: Integer;
i: Integer;
MyTableDef: TSqlitePassTableDef;
NewPanelFieldDefTitle: TPanelFieldDefTitle;
NewPanelFieldDef: TPanelFieldDefPropertiesValues;
PanelFieldDefTop, PanelFieldDefLeft, PanelFieldDefHOffset: Integer;
s: string;
begin
With MainForm do
begin
  PageControl.ActivePage := TsDataset;
  //
  DbImage.DataField := '';
  ComboBoxGraphicFields.Clear;
  ComboBoxGraphicFields.Text := '';
  DbMemo.DataField := '';
  ComboBoxMemoFields.Clear;
  ComboBoxMemoFields.Text := '';
  //
  { Reset Filter Action Hint}
  ActionDatasetFilterOnSelection.Hint := 'Select to filter on current selected field value';
  { Show Data }
  With Dataset do
  begin
  Close;
  { For test purpose }
  //RecordLowerLimit := 2;
  //RecordUpperLimit := 3;
  { }
  Database := Db;
  DatasetName := Node.Text;
  Open;
  PageControl.ActivePage.Caption := 'Dataset : ' + DatasetName;
  MemoSqlCreateStmt.Clear;
  MyTableDef := Db.TableDefs.FindTable(Node.Text);
  If Assigned(MyTableDef)
     then MemoSqlCreateStmt.Lines.Text := MyTableDef.Sql;
  MemoSqlSelectStmt.Clear;
  MemoSqlSelectStmt.Lines.Text := SQL.Text;
  if ReadOnly or not CanModify
     then begin
     DbNavDataset.VisibleButtons := [nbFirst, nbPrior, nbNext, nbLast, nbRefresh];
     ImageDatasetReadOnly.Visible := True;
     LabelDatasetReadOnly.Visible := True;
     end
     else begin
     DbNavDataset.VisibleButtons := [nbFirst, nbPrior, nbNext, nbLast, nbInsert, nbEdit, nbDelete, nbPost, nbCancel, nbRefresh];
     ImageDatasetReadOnly.Visible := False;
     LabelDatasetReadOnly.Visible := False;
     end;
  First;
  end;
  DataSource.DataSet := Dataset;

  { --- Display FieldDefs Infos ---  }
  ScrollBoxFieldDefsFieldNames.visible := False;
  ScrollBoxFieldDefsPropertiesValues.visible := False;

  For i := 0 to Pred(ListofPanelFieldDefProperties.Count)
    do begin
    TPanelFieldDefTitle(ListofPanelFieldDefFieldNames[i]).Free;
    TPanelFieldDefPropertiesValues(ListofPanelFieldDefProperties[i]).Free;
    end;

  ListofPanelFieldDefProperties.Clear;
  ListofPanelFieldDefFieldNames.Clear;

  PanelFieldDefTop := 2;
  PanelFieldDefLeft := 2;

   For i := 0 to Pred(Dataset.SQLSelectStmt.FieldDefs.Count) do
    begin
        NewPanelFieldDefTitle:= TPanelFieldDefTitle.CreateAtPos(ScrollboxFieldDefsFieldNames, PanelFieldDefTop, PanelFieldDefLeft + 2);
        NewPanelFieldDefTitle.Caption := Dataset.SQLSelectStmt.FieldDefs[i].FieldName;
        ListofPanelFieldDefFieldNames.Add(NewPanelFieldDefTitle);
        NewPanelFieldDef := TPanelFieldDefPropertiesValues.CreateAtPos(ScrollBoxFieldDefsPropertiesValues, PanelFieldDefTop, PanelFieldDefLeft);
        With NewPanelFieldDef do
        begin
        FDataType.Caption := FieldTypeToString(Dataset.SQLSelectStmt.FieldDefs[i].DataType);
        FDataType.Hint := FDataType.Caption;
        FAutoInc.Value := Dataset.SQLSelectStmt.FieldDefs[i].AutoInc;
        FDefaultValue.Caption := Dataset.SQLSelectStmt.FieldDefs[i].DefaultValue;
        FDefaultValue.Hint := FDefaultValue.Caption;
        FDisplayName.Caption := Dataset.SQLSelectStmt.FieldDefs[i].DisplayName;
        FDisplayName.Hint := FDisplayName.Caption;
        FFieldNo.Caption := IntToStr(Dataset.SQLSelectStmt.FieldDefs[i].FieldNo);
//        FFieldFullName.Caption := Dataset.SQLSelectStmt.FieldDefs[i].FieldFullName;
        FForeignKey.Value := Dataset.SQLSelectStmt.FieldDefs[i].ForeignKey;
        FHint.Caption := Dataset.SQLSelectStmt.FieldDefs[i].Hint;
        FHint.Hint := FHint.Caption;
        FIndexed.Value := Dataset.SQLSelectStmt.FieldDefs[i].Indexed;
        FInternalPrimaryKey.Value := Dataset.SQLSelectStmt.FieldDefs[i].InternalPrimaryKey;
        FNativeDataType.Caption := Dataset.SQLSelectStmt.FieldDefs[i].NativeDataType;
        FNativeDataType.Hint := FNativeDataType.Caption;
        FNativeDataTypeCode.Caption := IntToSTr(Dataset.SQLSelectStmt.FieldDefs[i].NativeDataTypeCode);
        FNotEmpty.Value := Dataset.SQLSelectStmt.FieldDefs[i].NotEmpty;
        FNoConstraints.Value := Dataset.SQLSelectStmt.FieldDefs[i].NoConstraints;
        FNotNull.Value := Dataset.SQLSelectStmt.FieldDefs[i].NotNull;
        FPrecision.Caption := IntToStr(Dataset.SQLSelectStmt.FieldDefs[i].Precision);
        FPrimaryKey.Value := Dataset.SQLSelectStmt.FieldDefs[i].PrimaryKey;
        FSize.Caption := IntToStr(Dataset.SQLSelectStmt.FieldDefs[i].Size);
        FUnique.Value := Dataset.SQLSelectStmt.FieldDefs[i].Unique;
        end;
        Case Dataset.SQLSelectStmt.FieldDefs[i].DataType of
          ftGraphic, ftBlob : ComboBoxGraphicFields.Items.Add(Dataset.SQLSelectStmt.FieldDefs[i].FieldName);
          ftMemo            : ComboBoxMemoFields.Items.Add(Dataset.SQLSelectStmt.FieldDefs[i].FieldName);
          end;

        PanelFieldDefHOffset := NewPanelFieldDef.Width + 2;
        Inc(PanelFieldDefLeft, PanelFieldDefHOffset);
        ListofPanelFieldDefProperties.Add(NewPanelFieldDef);
     end;


  ScrollbarHorizontal.Max := PanelFieldDefHOffset + 2000;
  ScrollBoxFieldDefsFieldNames.visible := True;
  ScrollBoxFieldDefsPropertiesValues.visible := True;


  { Display IndexDefs Infos }
  RefreshIndexList;

  { Display available Blobs fields }
  if ComboBoxGraphicFields.Items.Count > 0 then
     begin
     ComboBoxGraphicFields.Text := ComboBoxGraphicFields.Items[0];
     ComboBoxGraphicFieldsChange(Self);
     end;

  if ComboBoxMemoFields.Items.Count > 0 then
     begin
     ComboBoxMemoFields.Text := ComboBoxMemoFields.Items[0];
     ComboBoxMemoFieldsChange(Self);
     end;


  RefreshStatusBar;

end;
end;

procedure TMainForm.RefreshTreeview;
var
i: Integer;
TvItem: TTreeNode;
begin
Tv.Items.Clear;
DatabaseNode := Tv.Items.Add(nil,'Database');
TablesNode   := Tv.Items.AddChild(DatabaseNode,'Tables');
QueriesNode  := Tv.Items.AddChild(DatabaseNode,'Queries');
ViewsNode    := Tv.Items.AddChild(DatabaseNode,'Views');
TriggersNode := Tv.Items.AddChild(DatabaseNode,'Triggers');
SystemTablesNode := Tv.Items.AddChild(DatabaseNode,'System Tables');
SQLNode := Tv.Items.AddChild(DatabaseNode,'SQL Execute');

TablesNode.ImageIndex := 2;

for i:= 0 to Pred(Db.TableDefs.Count)
    do if Not Db.IsSystemTable(Db.TableDefs[i].TableName)
       then begin
            TvItem := Tv.Items.AddChild(TablesNode,Db.TableDefs[i].TableFullName);
            TvItem.ImageIndex := -1;
            end
            else Tv.Items.AddChild(SystemTablesNode,Db.TableDefs[i].TableFullName);

for i:= 0 to Pred(Db.QueryDefs.Count)
    do Tv.Items.AddChild(QueriesNode,Db.QueryDefs[i].QueryFullName);

for i:= 0 to Pred(Db.Views.Count)
    do Tv.Items.AddChild(ViewsNode,Db.Views[i].ViewName);

for i:= 0 to Pred(Db.Triggers.Count)
    do Tv.Items.AddChild(TriggersNode, Db.Triggers[i].TriggerName);

Tv.FullExpand;
Tv.Selected := DatabaseNode;
RefreshStatusBar;
end;


procedure TMainForm.ComboBoxMemoFieldsChange(Sender: TObject);
var
F: TField;
begin
if ComboBoxMemoFields.Text = '' then exit;
F := Dataset.FieldByName(ComboBoxMemoFields.Text);
if (F <> nil) and CbShowMemo.Checked
   then begin
        if F.DataType = ftMemo
           then DbMemo.DataField := ComboBoxMemoFields.Text;
        end
        else DbMemo.DataField := '';
end;

procedure TMainForm.RefreshActionListDatabase(Enable: Boolean);
var
i: integer;
begin
for i := 0 to Pred(ActionListDatabase.ActionCount) do
    TAction(ActionListDatabase.Actions[i]).Enabled := Enable;

ActionDatabaseOpen.Enabled := Not Enable;
ActionDatabaseTransactionCommit.Enabled := False;
ActionDatabaseTransactionRollback.Enabled := False;
ActionDatabaseDetach.Enabled := False;
RefreshToolBar(PanelDatabaseToolBar,True);
end;

{ --- Dataset Index --- }

{ Indexes Management }

procedure TMainForm.ActionIndexRenameExecute(Sender: TObject);
begin
FormRenameItem := TFormRenameItem.Create(Self);
FormRenameItem.LabelRenameItem.Caption := 'Rename index '
                               + ListBoxIndexDefs.Items[ListBoxIndexDefs.ItemIndex] + ' as :';
if FormRenameItem.ShowModal = mrOk
   then begin
   Dataset.Database.IndexDefs.RenameIndex(ListBoxIndexDefs.Items[ListBoxIndexDefs.ItemIndex], FormRenameItem.EditNewName.Text);
   RefreshIndexList;
   end;
FormRenameItem.Free;
end;

procedure TMainForm.ActionIndexCreateNewExecute(Sender: TObject);
begin
FormCreateNewIndex := TFormCreateNewIndex.Create(Self, Dataset);
if FormCreateNewIndex.ShowModal = mrOk
   then RefreshIndexList;
FormCreateNewIndex.Free;
end;

procedure TMainForm.ActionIndexDeleteExecute(Sender: TObject);
begin
Dataset.Database.IndexDefs.DeleteIndex(ListBoxIndexDefs.Items[ListBoxIndexDefs.ItemIndex]);
RefreshIndexList;
end;

procedure TMainForm.ActionIndexRefreshExecute(Sender: TObject);
begin
RefreshIndexList;
end;

procedure TMainForm.TsDatasetIndexesShow(Sender: TObject);
begin
RefreshToolBar(PanelIndexesToolBar, True)
end;

procedure TMainForm.SbCancelIndexChangesClick(Sender: TObject);
var
SelectedIndex: Integer;
begin
SelectedIndex:= ListBoxIndexDefs.ItemIndex;
ActionIndexRefreshExecute(Sender);
ListBoxIndexDefs.ItemIndex := SelectedIndex;
ListBoxIndexDefsClick(Self);
RefreshIndexSpeedButtons(False);
end;

procedure TMainForm.RefreshIndexSpeedButtons(Enable: Boolean);
begin
SbApplyIndexChanges.Enabled := Enable;
SbCancelIndexChanges.Enabled := Enable;
end;

procedure TMainForm.CheckBoxUniqueIndexClick(Sender: TObject);
begin
RefreshIndexSpeedButtons(True);
end;

procedure TMainForm.OnCbIndexedFieldClick(Sender: TObject);
var
i : Integer;
begin
  i := CbIndexedFields.IndexOf(Sender);
  if i =-1 then Exit;
  if TCheckBox(CbIndexedFields[i]).Checked
     then begin
          with TImage(ImIndexDirection[i]) do
          begin
          Picture.Assign(ImageIndexDirectionDesc.Picture);
          Tag := 1;
          Visible := True;
          end;
          end
     else TImage(ImIndexDirection[i]).Visible := False;
RefreshIndexSpeedButtons(True);
end;

procedure TMainForm.OnImIndexDirectionClick(Sender: TObject);
begin
With TImage(Sender) do
 begin
 if Tag = 1
    then Tag := 2
    else Tag := 1;

 if Tag = 1
    then Picture.Assign(ImageIndexDirectionAsc.Picture)
    else Picture.Assign(ImageIndexDirectionDesc.Picture);
 end;
RefreshIndexSpeedButtons(True);
end;

procedure TMainForm.RefreshIndexList;
var
i, VOffset: Integer;
aCheckBox: TCheckBox;
aImage: TImage;

begin
ListBoxIndexDefs.Clear;

{ Free Existing checkboxes and Images }
for i:= 0 to Pred(CbIndexedFields.Count)
    do begin
       TCheckBox(CbIndexedFields[i]).Free;
       TImage(ImIndexDirection[i]).Free;
       end;
CbIndexedFields.Clear;
ImIndexDirection.Clear;

{ no index available ? }
if Dataset.IndexDefs.count = 0 then exit;

{ We fill the listbox with indexes names }
For i := 0 to Pred(Dataset.IndexDefs.count) do
ListBoxIndexDefs.items.Add(Dataset.IndexDefs[i].IndexName);

{ Create necessary checkboxes and Images to display info }
VOffset := 0;
for i := 0 to Pred(Dataset.FieldCount) do
    Begin
     if (Dataset.Fields[i].FieldKind=fkData) and (Dataset.Fields[i].Visible)
        then begin
        aCheckBox := TCheckBox.Create(ScrollBoxIndexedFields);
        With aCheckBox do
             begin
             Parent := ScrollBoxIndexedFields;
             Caption:=Dataset.Fields[i].FieldName;
             Top  := (VOffset*20)+5;
             Left := 30;
             Width := 200;
             Height := 16;
             OnClick:=OnCbIndexedFieldClick;
             end;

        aImage := TImage.Create(ScrollBoxIndexedFields);
        With aImage do
             begin
             Parent := ScrollBoxIndexedFields;
             Top  := (VOffset*20)+4;
             Left := 6;
             Width := 16;
             Height := 16;
             Transparent := True;
             OnClick:=OnImIndexDirectionClick;
             end;
        Inc(VOffset);
        CbIndexedFields.Add(aCheckBox);
        ImIndexDirection.Add(aImage);
       end;
    end;

{ Select the first index in the listbox }
ListBoxIndexDefs.ItemIndex := 0;

{ Display corresponding info }
ListBoxIndexDefsClick(Self);

end;

{ --- Display current index infos --- }
procedure TMainForm.RefreshIndexInfos(CurrentIndex: TSqlitePassIndex);
var
i: Integer;
MyIndexCol: TSqlitePassIndexColumn;
Image: TImage;
begin
If CurrentIndex = nil then exit;
{ Show SQL Create statement for the selected index }
MemoSQLIndexCreateStmt.Clear;
MemoSqlIndexCreateStmt.Lines.Text := CurrentIndex.Sql;
{ Show fields used by the selected index and sort order }
For i := 0 to Pred(Dataset.FieldCount) do
    begin
    if (Dataset.Fields[i].FieldKind=fkData) and (Dataset.Fields[i].Visible)
    then begin
         MyIndexCol := CurrentIndex.Columns.FindColumn(Dataset.Fields[i].FieldName);
         TCheckBox(CbIndexedFields[i]).Checked := (MyIndexCol <> nil);
         Image := TImage(ImIndexDirection[i]);
         if MyIndexCol <> nil
            then begin
                 Case MyIndexCol.Direction of
                 cidAscending  : begin
                                 Tag := 1;
                                 Image.Picture.Assign(ImageIndexDirectionAsc.Picture);
                                 end;
                 cidDescending : begin
                                 Tag := 2;
                                 Image.Picture.Assign(ImageIndexDirectionDesc.Picture);
                                 end;
                 cidUnknown    : begin
                                 Tag := 3;
                                 Image.Picture.Assign(ImageIndexDirectionUnknown.Picture);
                                 end;
                 end; { Case }
                 Image.Visible := True;
                 end
                 else Image.Visible := False; { if MyIndexCol = nil }
        end; { Dataset.Fields[i]... }
    end; { For... }
CheckBoxUniqueIndex.Checked := CurrentIndex.Unique;
RefreshIndexSpeedButtons(False);
end;



procedure TMainForm.ComboBoxSQLStmtsChange(Sender: TObject);
begin
MemoSQLStmt.Clear;
MemoSQLStmt.Text := ComboBoxSQLStmts.Text;
end;

procedure TMainForm.TsSQLShow(Sender: TObject);
begin
With ComboBoxSQLStmts do
     if (Text = '') and (Items.Count > 0)
         then begin
              Text := Items[0];
              ComboBoxSQLStmtsChange(Sender);
              end;
end;


{ TPanelFieldDefPropertyValue }

constructor TPanelFieldDefPropertyValue.Create(AOwner: TPanel);
begin
Inherited Create(AOwner);
Parent := AOWner;
Height := 22;
Width := 102;
Color := clBtnface;
BevelInner := bvSpace;
BevelOuter := bvLowered;
Inc(TPanelFieldDefPropertiesValues(Parent).FTop, TPanelFieldDefPropertiesValues(Parent).FVOffset);
end;

constructor TPanelFieldDefPropertyValue.CreateAtPos(AOwner: TPanel;
  Top, Left: Integer);
begin
Create(AOwner);
Self.Top := Top;
Self.Left := Left;
end;

{ TPanelFieldDefPropertiesValues }

constructor TPanelFieldDefPropertiesValues.Create(AOwner: TComponent);
begin
Inherited Create(AOwner);
Parent := TScrollBox(AOwner);
end;

constructor TPanelFieldDefPropertiesValues.CreateAtPos(AOwner: TComponent; Top, Left: Integer);
begin
Create(AOwner);
Self.Top := Top;
Self.Left := Left;
Width := 110;
Height := 600;
Color := clBtnface;
ShowHint := True;
BevelInner := bvSpace;
BevelOuter := bvSpace;
FVOffset := 22;
FTop := 1;
FLeft := 4;
FDataType := TPanelFieldDefPropertyValue.CreateAtPos(Self, FTop, FLeft);
FAutoInc := TPanelFieldDefBooleanPropertyValue.CreateAtPos(Self, FTop, FLeft);
FDefaultValue := TPanelFieldDefPropertyValue.CreateAtPos(Self, FTop, FLeft);
FDisplayName := TPanelFieldDefPropertyValue.CreateAtPos(Self, FTop, FLeft);
FFieldNo := TPanelFieldDefPropertyValue.CreateAtPos(Self, FTop, FLeft);
FFieldFullName := TPanelFieldDefPropertyValue.CreateAtPos(Self, FTop, FLeft);
FForeignKey := TPanelFieldDefBooleanPropertyValue.CreateAtPos(Self, FTop, FLeft);
FHint := TPanelFieldDefPropertyValue.CreateAtPos(Self, FTop, FLeft);
FIndexed := TPanelFieldDefBooleanPropertyValue.CreateAtPos(Self, FTop, FLeft);
FInternalPrimaryKey := TPanelFieldDefBooleanPropertyValue.CreateAtPos(Self, FTop, FLeft);
FNativeDataType := TPanelFieldDefPropertyValue.CreateAtPos(Self, FTop, FLeft);
FNativeDataTypeCode := TPanelFieldDefPropertyValue.CreateAtPos(Self, FTop, FLeft);
FNotEmpty := TPanelFieldDefBooleanPropertyValue.CreateAtPos(Self, FTop, FLeft);
FNoConstraints := TPanelFieldDefBooleanPropertyValue.CreateAtPos(Self, FTop, FLeft);
FNotNull := TPanelFieldDefBooleanPropertyValue.CreateAtPos(Self, FTop, FLeft);
FPrecision := TPanelFieldDefPropertyValue.CreateAtPos(Self, FTop, FLeft);
FPrimaryKey := TPanelFieldDefBooleanPropertyValue.CreateAtPos(Self, FTop, FLeft);
FSize := TPanelFieldDefPropertyValue.CreateAtPos(Self, FTop, FLeft);
FUnique := TPanelFieldDefBooleanPropertyValue.CreateAtPos(Self, FTop, FLeft);
end;

destructor TPanelFieldDefPropertiesValues.Destroy;
begin
FDataType.Free;
FAutoInc.Free;
FDefaultValue.Free;
FDisplayName.Free;
FFieldNo.Free;
FFieldFullName.Free;
FForeignKey.Free;
FHint.Free;
FIndexed.Free;
FInternalPrimaryKey.Free;
FNativeDataType.Free;
FNativeDataTypeCode.Free;
FNotEmpty.Free;
FNoConstraints.Free;
FNotNull.Free;
FPrecision.Free;
FPrimaryKey.Free;
FSize.Free;
FUnique.Free;
Inherited Destroy;
end;

{ TPanelFieldDefBooleanPropertyValue }

constructor TPanelFieldDefBooleanPropertyValue.CreateAtPos(
  AOwner: TPanelFieldDefPropertiesValues; Top, Left: Integer);
begin
Inherited CreateAtPos(TPanel(AOwner), Top, Left);
FImage := TImage.Create(Self);
With FImage do
  begin
  Parent := Self;
  Width := 16;
  Height := 16;
  Transparent := True;
  Left := (Self.Width - Width) div 2;
  Top := (Self.Height - Height) div 2;
  end;
end;

destructor TPanelFieldDefBooleanPropertyValue.Destroy;
begin
FImage.Free;
Inherited Destroy;
end;

procedure TPanelFieldDefBooleanPropertyValue.SetFValue(
  const Value: Boolean);
begin
  FValue := Value;
  If FValue = True
     then FImage.Picture := MainForm.ImageCheck.Picture
     else FImage.Picture := nil;
end;

{ TPanelFieldDefTitle }

constructor TPanelFieldDefTitle.Create(AOwner: TComponent);
begin
Inherited Create(AOwner);
Parent := TScrollBox(AOwner);
Height := 22;
Width := 106;
Color := clBlack;
Font.Color := clWhite;
BevelInner := bvLowered;
BevelOuter := bvLowered;
end;

constructor TPanelFieldDefTitle.CreateAtPos(AOwner: TComponent; Top,
  Left: Integer);
begin
Create(AOwner);
Self.Top := Top;
Self.Left := Left;
end;

procedure TMainForm.ScrollBarVerticalScroll(Sender: TObject;
  ScrollCode: TScrollCode; var ScrollPos: Integer);
begin
{$IFNDEF FPC}
ScrollboxFieldDefsPropertiesNames.ScrollBy(0,ScrollbarVertical.Position-ScrollPos);
ScrollboxFieldDefsPropertiesValues.ScrollBy(0,ScrollbarVertical.Position-ScrollPos);
{$ENDIF}
end;

procedure TMainForm.ScrollBoxFieldDefsPropertiesValuesResize(
  Sender: TObject);
begin
(*ScrollbarVertical.Min := 0;
ScrollbarVertical.Max := ScrollBoxFieldDefsPropertiesValues.Height;
ScrollbarHorizontal.Min := 0;
ScrollbarHorizontal.Max := ScrollBoxFieldDefsPropertiesValues.Width;*)
end;

procedure TMainForm.ScrollBarHorizontalScroll(Sender: TObject;
  ScrollCode: TScrollCode; var ScrollPos: Integer);
begin
{$IFNDEF FPC}
ScrollboxFieldDefsFieldNames.ScrollBy(ScrollbarHorizontal.Position-ScrollPos,0);
ScrollboxFieldDefsPropertiesValues.ScrollBy(ScrollbarHorizontal.Position-ScrollPos,0);
{$ENDIF}
end;

procedure TMainForm.SbAppendRecordsClick(Sender: TObject);
var
i, j, TickCount, RecordCount: Integer;
begin
// Inserting Records - Speed Test.
Dataset.DisableControls;
//TickCount := Integer(GetTickCount);
RecordCount := StrToInt(EditRecordCount.Text);
if CheckBoxUseTransaction.Checked
   then Dataset.Database.Engine.Transaction.Start;

for i := 0 to RecordCount do
begin
Dataset.Append;
for j := 0 to Pred(Dataset.Fields.count) do
Case Dataset.Fields[j].DataType of
     ftString : Dataset.Fields[j].Value := 'Enre num : ' + IntToStr(i) + '-T' + IntToStr(TickCount);
     ftInteger: Dataset.Fields[j].Value := TickCount + j;
     ftFloat  : Dataset.Fields[j].Value := TickCount + j + 0.57;
     end;
Dataset.Post;
end;
if CheckBoxUseTransaction.Checked
   then Dataset.Database.Engine.Transaction.Commit;
Dataset.EnableControls;
RefreshStatusBar;
end;


{ -------------------------------- }
{ --- Display Utility routines --- }
{ -------------------------------- }

Procedure TMainForm.ResfreshMenu;
var
i, j : integer;
begin
For i := 0 to Pred(MainMenu.Items.Count) do
    For j := 0 to Pred(MainMenu.Items[i].Count) do
    begin
    if TAction(MainMenu.Items[i].Items[j].Action) <> nil
       then DrawActionBitmap(MainMenu.Items[i].Items[j].Bitmap, MainMenu.Items[i].Items[j].ImageIndex, True, MainMenu.Items[i].Items[j].Enabled);
    if MainMenu.Items[i].Items[j].Caption <> '-'
       then MainMenu.Items[i].Items[j].Caption := '  '+MainMenu.Items[i].Items[j].Caption;
    end;
end;


{ ToolBar }
procedure TMainForm.InitToolBar(ToolBar: TPanel; ActionList: TActionList);
Const
ToolbarHeight =30;
ButtonHeight = 24;

var
i, HOffset: Integer;
Im: TImage;
begin
HOffset := 6;
with ToolBar do
begin
Height := ToolbarHeight;
Color := cl3DLight;
OnMouseMove := OnToolBarMouseMove;
ShowHint := True;
end;

for i := 0 to Pred(ActionList.ActionCount) do
begin
   Im := TImage.Create(ToolBar);
   with Im do
     begin
     Parent := ToolBar;
     AutoSize := False;
     if TAction(ActionList.Actions[i]).Caption = '-'
        then begin { Draw separator }
        Top := ((ToolBarHeight - ButtonHeight) div 2);
        Height := ButtonHeight;
        Width := 2;
        Left := HOffset;
        Inc(HOffset, Width + 3);
        Action := ActionList.Actions[i];
        Canvas.Brush.Color := clBtnHighlight;
        Canvas.FillRect(Rect(0,0,1,ButtonHeight-2));
        Canvas.Brush.Color := clBtnShadow;
        Canvas.FillRect(Rect(1,0,2,ButtonHeight-2));
        end
        else begin { Draw Action button }
        Top := ((ToolBarHeight - ButtonHeight) div 2);
        Height := ButtonHeight;
        Width := ButtonHeight;
        Left := HOffset;
        Inc(HOffset, Width + 2);
        Action := ActionList.Actions[i];
        OnMouseMove := OnToolBarBtnMouseMove;
        OnClick := OnToolBarBtnClick;
        end;
   end;
end;
end;

procedure TMainForm.Internal_OnToolBarBtnMouseMove(ToolBar: TPanel; Im: TImage);
begin
RefreshToolBar(ToolBar, False);
With Im do
  begin
  canvas.Brush.Color := $00FF8080;
  Canvas.FrameRect(Rect(0,0,Im.Width, Im.Height));
  Tag := 1;
  end;
end;

procedure TMainForm.Internal_OnToolBarBtnClick(Im: TImage);
begin
With Im do begin
canvas.Brush.Color := clRed;
Canvas.FrameRect(Rect(0,0,Im.Width, Im.Height));
Refresh;
Sleep(60);
canvas.Brush.Color := cl3DLight;
Canvas.FrameRect(Rect(0,0,Im.Width, Im.Height));
Action.Execute;
end;
end;

{ ToolBar - end }

procedure TMainForm.DrawActionBitmap(aBitmap: TBitmap; ImageIndex: Integer; Menu, Enabled: Boolean);
var
offset: integer;
R: TRect;
begin
if Menu
   then begin
        aBitmap.Height := 16;
        aBitmap.Width := 16;
        offset := 0;
        end
   else begin
        aBitmap.Height := 22;
        aBitmap.Width := 22;
        R := Rect(0,0,aBitmap.Width,aBitmap.Height);
        {$IFDEF FPC}
        aBitmap.Canvas.Frame3d(R, 1, bvLowered);
        {$ELSE}
        Frame3d(aBitmap.Canvas, R, clBtnHighlight,cl3DDkShadow,1);
        R := Rect(1,1,aBitmap.Width-1,aBitmap.Height-1);
        Frame3d(aBitmap.Canvas, R, cl3DDkShadow,clBtnHighlight,1);
        {$ENDIF}
        offset := 3;
        end;
aBitmap.TransparentColor := clFuchsia;
If Enabled
   then ImageListEnabled.Draw(aBitmap.Canvas, offset, offset, ImageIndex)
   else ImageListDisabled.Draw(aBitmap.Canvas, offset, offset, ImageIndex);

end;

procedure TMainForm.RefreshToolBar(ToolBar: TPanel; RefreshAll: Boolean);
var
i: Integer;
ImTemp: TImage;
Act: TAction;
begin
for i := 0 to Pred(ToolBar.ControlCount) do
begin
ImTemp := TImage(ToolBar.Controls[i]);
Act:= TAction(ImTemp.Action);
if (Act <> nil) then
if (ImTemp.Tag = 1) or (RefreshAll and (Act.Caption <> '-')) then
     begin
     DrawActionBitmap(imTemp.Picture.Bitmap, Act.ImageIndex, False, (Act.Enabled and Assigned(Act.OnExecute)));
     ImTemp.Tag := 0;
     end;
end;
end;

function TMainForm.DatabaseTypeAsString: String;
begin
Case Db.DatabaseType of
     dbtSqlitePass  : Result := 'SQLitePass';
     dbtKexi        : Result := 'Kexi';
     dbtSqliteAdmin : Result := 'SQLite Administrator';
     dbtSqlite4Fpc  : Result := 'SQLite4FPC';
     dbtSqliteExpert: Result := 'SQLite Expert';
     else             Result := 'Unknown...';
     end;
end;

procedure TMainForm.ActionDatasetFilterOnSelectionExecute(Sender: TObject);
var
f: TField;
S, FilterString : String;
begin
f := DbGridDatasetData.SelectedField;

if Dataset.Filtered or (f = nil)
   then begin
        Dataset.Filtered := False;
        ActionDatasetFilterOnSelection.Hint := 'Select to filter on current selected field value';
        ActionDatasetFilterOnSelection.Checked := False;
        end
   else begin
        ActionDatasetFilterOnSelection.Checked := True;
        Case f.DataType of
                ftDateTime, ftDate, ftTime : S := '#';
                ftString, ftMemo           : S := '"';
               else
                S := '';
               End;
        FilterString := '[' + f.FieldName + '] = ' + S + f.AsString + S;
        Dataset.Filter := FilterString;
        Dataset.Filtered := True;
        ActionDatasetFilterOnSelection.Hint := 'Current filter is : ' + FilterString;
        end;
end;

procedure TMainForm.ActionDatasetFilterOnSelectionUpdate(Sender: TObject);
begin
Enabled := (DbGridDatasetData.SelectedField <> nil);
end;



{ MRU Files }

procedure TMainForm.LoadMRUFiles;
begin
DbSettings.Open;
DatasetSettings.DatasetName := 'MRUFiles';
DatasetSettings.Open;
MRUFileList.Assign(DatasetSettings.FieldByName('Files'));
DbSettings.Close;
UpdateMRUFiles;
end;

procedure TMainForm.SaveMRUFiles;
begin
DbSettings.Open;
With DatasetSettings do
     begin
     DatasetName := 'MRUFiles';
     Open;
     First;
     Edit;
     DatasetSettings.FieldByName('Files').Assign(MRUFileList);
     Post;
     Close;
     end;
DbSettings.Close;
end;

procedure TMainForm.AddNewMRUFile(FileName: String);
var
IndexOf: Integer;
begin
IndexOf := MRUFileList.IndexOf(FileName);
  if IndexOf = -1
     then MRUFileList.Insert(0, FileName)
     else MRUFileList.Exchange(0, IndexOf);

  if MRUFileList.Count > MaxMRUFilesCount
     then MRUFileList.Delete(Pred(MRUFileList.Count));
end;


procedure TMainForm.UpdateMRUFiles;
var
  i: Integer;
  NewItem: TMenuItem;
begin
  { Clear Menu Items }
  While MainMenu.Items[0].Count > ActionListDatabase.ActionCount
        do MainMenu.Items[0].Delete(Pred(MainMenu.Items[0].Count));

  if MRUFileList.Count > 0 then
     begin
     NewItem := TMenuItem.Create(MainMenu);
     NewItem.Caption := '-';
     MainMenu.Items[0].Add(NewItem);

     for i := 0 to Pred(MRUFileList.Count) do
         begin
         NewItem := TMenuItem.Create(MainMenu);
         NewItem.Caption := MRUFileList.Strings[i];
         //NewItem.ShortCut := TextToShortCut('&' + IntToStr(i+1));
         NewItem.OnClick := MRUFileOpen;
         if FileExists(MRUFileList.Strings[i])
            then MainMenu.Items[0].Add(NewItem);
         end;
     end;
end;

procedure TMainForm.MRUFileOpen(Sender: TObject);
var
FileName: String;
begin
FileName := (TMenuItem(Sender).Caption);
{ Caption returns leading blanck space so we remove it (D4) }
OpenDatabaseFile(Trim(FileName));
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
{ Db and Dataset to store program settings }
SaveMRUFiles;
end;

initialization
 {$IFDEF FPC}
  {$I SQLitePassDboTest.lrs}
 {$ENDIF}
end.

 